
#include "helium.h"


//mBoxStat bits:
//   bit 0 indicates wheather a task is waiting for that mailbox
//   bit 1 indicates wheather that mailbox contains valid data.
char mBoxStat[NUMMBOX] ;
char mBoxWait[NUMMBOX] ; // Each element holds the,priority level of the task that's waiting on that mailbox, if any
int  mBoxData[NUMMBOX] ; // Holds the data entries for each mailbox.

char mutexStat ;
char currTask;
char Tasks ;
int Stacks[NUMTASKS];
char TickBlock[NUMTASKS];  // Holds the number of system clock ticks to wait before the task becomes ready to run.

//  The entries in this table give the bit number of the least significant
//  bit that is set for the corresponding entry. For example, for entry number
//  6 = (00000110 b) the table contains a 1 because bit 1 is the least significant bit that is set.
//             ^
//             |----- Bit 1 (LSB that is set)
//  Entry 8 = (00001000 b) contains a 3 because bit 3 is the least significant bit
//  that is set. This is used by the scheduler to determine which task is the highest
//  priority task ready to run. The byte Tasks (declared in this file) maintains a list
//  of which tasks are ready to run. The highest-priority task (with task number 0)
//  is ready to run if bit 0 of Tasks is set. The second-highest priority task (with
//  task priority 1) is ready to run if bit 1 is set. To determine the highest priority
//  task that is ready to run, the scheduler indexes into the array taskResolutionTable.
//  For example, if Tasks contained (00101100 b = 44 d) the scheduler would read entry
//  number 44 in the taskResolutionTable, and it would find that entry 44 contained the
//  number 2, which, upon inspection of the variable Tasks, we can see is the highest
//  priority task ready to run.
const char taskResolutionTable[] = {
  0,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,
  0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,
  1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,
  0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,
  2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,
  0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,
  1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,
  0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,
  3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0
} ;


// Each entry in this table contains a byte that has a single 1
// in the bit position that corresponds to its index number. For
// example, entry 3 contains 00100000 which has a 1 in the thrid
// bit position.
const char bitPosTable[] = {
  1, 2, 4, 8, 16, 32, 64, 128 
};
