#define NUMTASKS 8
#define NUMMBOX  2




// This is the C function prototype for a label in the middle
// of TickISR just after all the array elements of TickBlock
// have been decremented. TickISRTaskSwitch is the scheduler.
// It returns using an RTI instruction, but it does not push
// the H register onto the stack like a normal ISR would.
void __interrupt TickISRTaskSwitch();


void TaskSw(char) ;
void TaskCreate( char taskNum, void (*t)(), int *stack, char stackSize ) ;
void TaskDestroy( char taskNum ) ;
void StartExecution(void) ;
void TimeBlock(char) ;
void mBoxPost( char mBoxNum, int data ) ;
extern int mBoxPend( char mBoxNum ) ;
void mutexTake(char mutexNum) ;
void mutexRelease(char mutexNum) ;



extern __interrupt void TickISR(void) ;

//Functions in cpu-specific.asm
extern void INTR_SW_TSK() ;
extern void SaveSP(void) ;

#define InterruptSwitchTasks() asm(jmp INTR_SW_TSK)
#define ClearTimerIntr() //i = TPMSC ; TPMSC_TOF = 0 ;


extern char currTask ;
extern char mBoxWait[NUMMBOX] ;
extern char mBoxStat[NUMMBOX] ;
extern int mBoxData[NUMMBOX] ;
extern char TickBlock[NUMTASKS] ;
extern char Tasks;
extern const char taskResolutionTable[] ;
extern const char bitPosTable[] ;
extern int Stacks[NUMTASKS] ;
extern char mutexStat ;