#include "helium.h"
#include <hidef.h>


void mBoxPost( char mBoxNum, int data ){
     // If a task is already waiting on the mailbox, do not set the valid data bit in the status byte. Just pass the data directly to the task's interrupt stack frame and return.
     if( mBoxStat[mBoxNum] & 0x01 != 0 ){  // If a task is already waiting on this mailbox.
        *((char*)Stacks[mBoxWait[mBoxNum]]+3) = (char)data ;  // put the low byte of data on the stack frame where x is stored
        *((char*)Stacks[mBoxWait[mBoxNum]]) = (char)(data>>8) ;  // put the high byte of data on the stack frame where h is stored
        Tasks |= bitPosTable[mBoxWait[mBoxNum]] ;   // Make the task ready to run again.
        return ;
     } else { // If no task is waiting for data, but the data in the box and return.
        mBoxData[mBoxNum] = data ;   // Put the data in the mailbox.
        mBoxStat[mBoxNum] |= 0x02 ;  // Indicate that the mailbox contains valid data
        return ;
     }
  
}



int mBoxPend( char mBoxNum ){
     DisableInterrupts ;
     if( (mBoxStat[mBoxNum] & 0x02) != 0 ){  // if valid data is present in the mailbox
        mBoxStat[mBoxNum] &= 0xfc ;   // Clear the valid data bit and the task waiting bit
        EnableInterrupts ;
        return mBoxData[mBoxNum] ;
     }else{
        mBoxStat[mBoxNum] |= 0x01 ;   // Indicate that a task is waiting for the mailbox
        mBoxWait[mBoxNum] = currTask ;         // tell which task is waiting for the mailbox.
        Tasks &= ~(bitPosTable[currTask]) ;     // indicate that the task is not ready to run.
        asm( ais #-5 ) ;    // Block until mailbox is filled with data
        asm( jmp TickISRTaskSwitch ) ;
     }
}