#include "helium.h"



void TaskCreate( char taskNum, void (*t)(), int *stack, char stackSize ) {
    char temp ;
        
    temp = 1<<taskNum ;
    Tasks |= temp ;  // indicate that the task exists and is ready to run.
    Stacks[taskNum] = (int)stack + stackSize - 1 ; // Point the task's SP to the top address of the array that represents its stack.
    *(int*)(Stacks[taskNum]-1) = (int)t ;   // Put the address of the function that implements the task on its stack
    Stacks[taskNum] -= 5 ;                  // in an interrupt stack frame.
}


// Takes the task out of the list of tasks ready to run.
// If the task is waiting on a mailbox or for a number of clock ticks
// to pass, it is taken out of the mailbox wait list and the number of
// clock ticks it has to wait for to be rescheduled is set to zero.
void TaskDestroy( char taskNum ) {
    char temp ;
    
    temp = ~(1<<taskNum) ;
    Tasks &= temp ;
    
    for( temp = 0 ; temp < NUMMBOX ; temp++ ) {
      if( mBoxWait[temp] == taskNum ) mBoxWait[temp] = 0 ;
    }
    TickBlock[taskNum] = 0 ;
  
}